' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2011/ 1/14 
'
' FVC05 Continue Grab Sample Program
' -----------------------------------------------------------------
Public Class Form_FVC05_CONTGRABSAMPLE

    Private m_image_CH0 As List(Of FVIL.Data.CFviImage) = New List(Of FVIL.Data.CFviImage)     'A荞CH0p摜i[̈
    Private m_image_CH1 As List(Of FVIL.Data.CFviImage) = New List(Of FVIL.Data.CFviImage)     'A荞CH1p摜i[̈
    Private m_image_CH0BIN As List(Of FVIL.Data.CFviImage) = New List(Of FVIL.Data.CFviImage)  'A荞2lCH0p摜i[̈
    Private m_image_CH1BIN As List(Of FVIL.Data.CFviImage) = New List(Of FVIL.Data.CFviImage)  'A荞2lCH1p摜i[̈
    Private m_video As FVIL.Video.CFviVideoFVC05 = New FVIL.Video.CFviVideoFVC05()  'FVC05NX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()            'ԌvNX

    Dim m_intBufImgIndex As Integer                                                 '摜IuWFNgԍ
    Dim intErr As Integer                                                           'G[ԍi[ϐ
    Public m_strIniFilePath As String                                               'init@CitpXj

    Private m_flgVideoOpened As Boolean                                             'rfIfoCX̃I[v
    Private m_flgFreerun As Boolean                                                 't[̏

    'FVC05[Jobt@gp̒萔
    Private Const FVC05_LOCALMEM_SIZE As Integer = 16777216                         '0x01000000(16MB)
    Private Const LOCAL_BUFFER_BOUNDARY As Integer = 262144                         '0x40000(256KB)
    Private Const LOCAL_BUFFER_MASK As Integer = 262143                             '0x3FFFF(LOCAL_BUFFER_BOUNDARY - 1)

    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ԕϐ̏
        m_flgVideoOpened = False
        m_flgFreerun = False

        'vԃeLXg{bNX
        TextBoxTime.Text = "0.000"
        't[eLXg{bNX
        TextBoxFrame.Text = "0"
        'Lv`[eLXg{bNX
        TextBoxCaptureNumber.Text = "10"
        '\摜ԍ
        TextBoxBufImgIndex.Text = "0"
        '[Jobt@mۍő喇
        TextBoxMaxImgNum.Text = "0"
        '[Jobt@mۖ
        NumericUpDownBufConfigNum.Value = 0

    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()

    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMainFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Try
            'bNꂽ܂B 
            If (m_video.ContinuousGrab.IsMemoryLocked) Then
                '荞݂̒~
                m_video.ContinuousGrab.StopCapture()
                '摜bN̉
                m_video.ContinuousGrab.MemoryUnlock()
            End If
            'rfIfoCXI[vĂꍇ̓N[Y
            If (m_flgVideoOpened = True) Then
                m_video.Close()
                m_flgVideoOpened = False
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()

        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ

        'init@C̑I
        m_strIniFilePath = ""
        If (Form_BROWSEINI.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        End If

        If (m_strIniFilePath.Length > 0) Then
            Try
                'rfIfoCXI[vĂꍇ̓N[Y
                If (m_video.IsOpen = True) Then
                    m_video.Close()
                    m_flgVideoOpened = False
                End If

                'foCXI[v
                m_video.Open(-1, 0)
                m_flgVideoOpened = True

                'VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)

                'QJ荞݂ɐݒ
                m_video.SimGrab = 2

                'init@CR|[lgɐݒ
                If (m_strIniFilePath.Length > 0) Then
                    m_video.LoadIniFile(m_strIniFilePath)
                End If

                'Xe[^X\̍XV
                'e`l̃Xe[^X擾
                'rfI̓ItZbg(CH0)̎擾
                NumericUpDownOffsetCH0.Value = m_video.VideoOffsetCH0
                'Ql臒l(CH0)̎擾
                NumericUpDownThresholdCH0.Value = m_video.BinarizeCH0.Threshold
                'rfI̓ItZbg(CH1)̎擾
                NumericUpDownOffsetCH1.Value = m_video.VideoOffsetCH1
                'Ql臒l(CH1)̎擾
                NumericUpDownThresholdCH1.Value = m_video.BinarizeCH1.Threshold

            Catch ex As Exception
                'G[
                intErr = m_video.ErrorCode
                MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try

        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If

    End Sub

    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub ButtonGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabOne.Click

        Dim msec As Double
        Dim status As Boolean

        Try
            If (m_video.ContinuousGrab.IsMemoryLocked()) Then
                '摜bNĂJ
                m_video.ContinuousGrab.MemoryUnlock()
            End If

            '[Jobt@蓖Đݒ
            fnSetBufConfig()

            '摜bN
            status = fnMemLock(1)
            If (status = False) Then
                't[~
                fnStopFreerun()
                Exit Sub
            End If

            'ԑJn
            m_timer.Start()
            'J荞
            m_video.ContinuousGrab.GrabSync(1)
            'ԑI
            msec = m_timer.Stop()
            '莞ԕ\
            TextBoxTime.Text = msec.ToString("0.000")
            'ĕ`
            CFviImageViewCH0.Refresh()
            CFviImageViewCH1.Refresh()
            CFviImageViewCH0BIN.Refresh()
            CFviImageViewCH1BIN.Refresh()
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Grab Continue{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' t[JnE~B
    ''' </remarks>
    Private Sub ButtonGrabContinue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabContinue.Click

        Dim status As Boolean

        '{^\ύX
        If (m_flgFreerun = True) Then
            't[~
            fnStopFreerun()
        Else
            Try
                'vԃeLXg{bNX
                TextBoxTime.Text = "0.000"
                't[eLXg{bNX
                TextBoxFrame.Text = "0"
                ButtonGrabContinue.Text = "Stop"
                ButtonGrabOne.Enabled = False
                ButtonLeft.Enabled = False
                ButtonRight.Enabled = False
                NumericUpDownLockImgNum.Enabled = False

                If (m_video.ContinuousGrab.IsMemoryLocked()) Then
                    '摜bNĂJ
                    m_video.ContinuousGrab.MemoryUnlock()
                End If

                '[Jobt@蓖Đݒ
                fnSetBufConfig()

                '摜bN
                status = fnMemLock(NumericUpDownLockImgNum.Value)
                If (status = False) Then
                    't[~
                    fnStopFreerun()
                    Exit Sub
                End If

                't[Jn
                m_flgFreerun = True
                Timer1.Interval = 50
                Timer1.Start()
                'AJ荞
                m_video.ContinuousGrab.GrabASync(TextBoxCaptureNumber.Text)
            Catch ex As Exception
                't[~
                fnStopFreerun()

                'G[
                intErr = m_video.ErrorCode
                MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
        Application.DoEvents()

    End Sub

    ''' <summary>
    ''' t[
    ''' </summary>
    ''' <remarks>
    ''' AJ荞݁B
    ''' </remarks>
    Private Sub Timer1Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Timer1.Stop()
        Try
            If (m_flgFreerun = True) Then
                't[\XV
                TextBoxFrame.Text = m_video.ContinuousGrab.QueryCaptureNo.TotalFrameCount

                'ŐVt[Zbg
                If (CheckBoxCH0Gray.Checked = True) Then
                    CFviImageViewCH0.Image = m_image_CH0(m_video.ContinuousGrab.QueryCaptureNo.LastFrameNo)
                Else
                    CFviImageViewCH0.Image = Nothing
                End If
                If (CheckBoxCH1Gray.Checked = True) Then
                    CFviImageViewCH1.Image = m_image_CH1(m_video.ContinuousGrab.QueryCaptureNo.LastFrameNo)
                Else
                    CFviImageViewCH1.Image = Nothing
                End If
                If (CheckBoxCH0Bin.Checked = True) Then
                    CFviImageViewCH0BIN.Image = m_image_CH0BIN(m_video.ContinuousGrab.QueryCaptureNo.LastFrameNo)
                Else
                    CFviImageViewCH0BIN.Image = Nothing
                End If
                If (CheckBoxCH1Bin.Checked = True) Then
                    CFviImageViewCH1BIN.Image = m_image_CH1BIN(m_video.ContinuousGrab.QueryCaptureNo.LastFrameNo)
                Else
                    CFviImageViewCH1BIN.Image = Nothing
                End If

                'ĕ`
                CFviImageViewCH0.Refresh()
                CFviImageViewCH1.Refresh()
                CFviImageViewCH0BIN.Refresh()
                CFviImageViewCH1BIN.Refresh()
                't[pE~
                If ((TextBoxCaptureNumber.Text > m_video.ContinuousGrab.QueryCaptureNo.TotalFrameCount) Or (TextBoxCaptureNumber.Text = 0)) Then
                    Timer1.Start()
                Else
                    't[~
                    fnStopFreerun()
                End If
            End If
            Timer1.Enabled = True

        Catch ex As Exception
            't[~
            fnStopFreerun()
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' [Jobt@蓖Đݒ֐
    ''' </summary>
    ''' <remarks>
    ''' [Jobt@蓖ĐݒύXB
    ''' </remarks>
    Private Sub fnSetBufConfig()
        Dim Channel As FVIL.Video.CFviFBufConfigNum
        Channel.Channel = 0
        Channel.Num = NumericUpDownBufConfigNum.Value

        If (CheckBoxCH0Gray.Checked = True) Then
            Channel.ChannelGray0 = True
        End If
        If (CheckBoxCH1Gray.Checked = True) Then
            Channel.ChannelGray1 = True
        End If
        If (CheckBoxCH0Bin.Checked = True) Then
            Channel.ChannelBin0 = True
        End If
        If (CheckBoxCH1Bin.Checked = True) Then
            Channel.ChannelBin1 = True
        End If
        m_video.FBufConfigNum = Channel
    End Sub

    ''' <summary>
    ''' 摜bN֐
    ''' </summary>
    ''' <remarks>
    ''' 摜bNB
    ''' </remarks>
    Private Function fnMemLock(ByVal LockImgNum As Integer) As Boolean
        Try
            Dim LockNum As Integer
            'i[̈NA
            m_image_CH0.Clear()
            m_image_CH1.Clear()
            m_image_CH0BIN.Clear()
            m_image_CH1BIN.Clear()
            If (CheckBoxCH0Gray.Checked = True) Then
                For LockNum = 0 To LockImgNum
                    '摜mېi[̈ǉ
                    m_image_CH0.Add(New FVIL.Data.CFviImage(m_video.ImageHorz, m_video.ImageVert, FVIL.ImageType.UC8, 1))
                Next
                'A荞ݐ̉摜ǗNX̃RNVݒ
                m_video.ContinuousGrab.Gray0Images = m_image_CH0
                '`imagẽZbg
                CFviImageViewCH0.Image = m_image_CH0(0)
            Else
                'A荞ݐ̉摜ǗNX̃RNVݒ
                m_video.ContinuousGrab.Gray0Images = Nothing
                '`imagẽZbg
                CFviImageViewCH0.Image = Nothing
            End If
            If (CheckBoxCH1Gray.Checked = True) Then
                For LockNum = 0 To LockImgNum
                    '摜mېi[̈ǉ
                    m_image_CH1.Add(New FVIL.Data.CFviImage(m_video.ImageHorz, m_video.ImageVert, FVIL.ImageType.UC8, 1))
                Next
                'A荞ݐ̉摜ǗNX̃RNVݒ
                m_video.ContinuousGrab.Gray1Images = m_image_CH1
                '`imagẽZbg
                CFviImageViewCH1.Image = m_image_CH1(0)
            Else
                'A荞ݐ̉摜ǗNX̃RNVݒ
                m_video.ContinuousGrab.Gray1Images = Nothing
                '`imagẽZbg
                CFviImageViewCH1.Image = Nothing
            End If
            If (CheckBoxCH0Bin.Checked = True) Then
                For LockNum = 0 To LockImgNum
                    '摜mېi[̈ǉ
                    m_image_CH0BIN.Add(New FVIL.Data.CFviImage(m_video.ImageHorz, m_video.ImageVert, FVIL.ImageType.BIN, 1))
                Next
                'A荞ݐ̉摜ǗNX̃RNVݒ
                m_video.ContinuousGrab.Bin0Images = m_image_CH0BIN
                '`imagẽZbg
                CFviImageViewCH0BIN.Image = m_image_CH0BIN(0)
            Else
                'A荞ݐ̉摜ǗNX̃RNVݒ
                m_video.ContinuousGrab.Bin0Images = Nothing
                '`imagẽZbg
                CFviImageViewCH0BIN.Image = Nothing
            End If
            If (CheckBoxCH1Bin.Checked = True) Then
                For LockNum = 0 To LockImgNum
                    '摜mېi[̈ǉ
                    m_image_CH1BIN.Add(New FVIL.Data.CFviImage(m_video.ImageHorz, m_video.ImageVert, FVIL.ImageType.BIN, 1))
                Next
                'A荞ݐ̉摜ǗNX̃RNVݒ
                m_video.ContinuousGrab.Bin1Images = m_image_CH1BIN
                '`imagẽZbg
                CFviImageViewCH1BIN.Image = m_image_CH1BIN(0)
            Else
                'A荞ݐ̉摜ǗNX̃RNVݒ
                m_video.ContinuousGrab.Bin1Images = Nothing
                '`imagẽZbg
                CFviImageViewCH1BIN.Image = Nothing
            End If
            '摜bN
            m_video.ContinuousGrab.MemoryLock(LockImgNum)
            fnMemLock = True
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            fnMemLock = False
        End Try
    End Function

    ''' <summary>
    ''' t[~֐
    ''' </summary>
    ''' <remarks>
    ''' t[~ƊeXe[^XύXB
    ''' </remarks>
    Private Sub fnStopFreerun()
        Try
            Timer1.Stop()
            Timer1.Enabled = False
            '摜荞݂̒~()
            m_video.ContinuousGrab.StopCapture()
            m_flgFreerun = False
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            ButtonLeft.Enabled = True
            ButtonRight.Enabled = True
            NumericUpDownLockImgNum.Enabled = True
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜̔ԍ߂B
    ''' </remarks>
    Private Sub ButtonLeft_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLeft.Click
        Dim size As Integer

        m_intBufImgIndex = TextBoxBufImgIndex.Text - 1
        size = NumericUpDownLockImgNum.Value
        If (m_intBufImgIndex < 0) Then
            m_intBufImgIndex = size - 1
        End If
        If (m_intBufImgIndex < 0) Then
            m_intBufImgIndex = 0
        End If

        TextBoxBufImgIndex.Text = m_intBufImgIndex.ToString
        If (m_image_CH0.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH0.Image = m_image_CH0(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH0.Refresh()
        End If
        If (m_image_CH1.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH1.Image = m_image_CH1(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH1.Refresh()
        End If
        If (m_image_CH0BIN.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH0BIN.Image = m_image_CH0BIN(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH0BIN.Refresh()
        End If
        If (m_image_CH1BIN.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH1BIN.Image = m_image_CH1BIN(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH1BIN.Refresh()
        End If

    End Sub

    ''' <summary>
    ''' {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜̔ԍi߂B
    ''' </remarks>
    Private Sub ButtonRight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRight.Click
        Dim size As Integer

        m_intBufImgIndex = TextBoxBufImgIndex.Text + 1
        size = NumericUpDownLockImgNum.Value
        If (m_intBufImgIndex >= size) Then
            m_intBufImgIndex = 0
        End If

        TextBoxBufImgIndex.Text = m_intBufImgIndex.ToString
        If (m_image_CH0.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH0.Image = m_image_CH0(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH0.Refresh()
        End If
        If (m_image_CH1.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH1.Image = m_image_CH1(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH1.Refresh()
        End If
        If (m_image_CH0BIN.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH0BIN.Image = m_image_CH0BIN(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH0BIN.Refresh()
        End If
        If (m_image_CH1BIN.Count > 0) Then
            '\摜Zbg
            CFviImageViewCH1BIN.Image = m_image_CH1BIN(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageViewCH1BIN.Refresh()
        End If

    End Sub

    ''' <summary>
    ''' Offset CH0 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH0)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownOffsetCH0_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownOffsetCH0.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                '`lOɐݒ
                m_video.VideoOffsetCH0 = NumericUpDownOffsetCH0.Value
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Offset CH1 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH1)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownOffsetCH1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownOffsetCH1.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                '`lPɐݒ
                m_video.VideoOffsetCH1 = NumericUpDownOffsetCH1.Value
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Threshold CH0 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH0)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownThresholdCH0_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownThresholdCH0.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                Dim bin As FVIL.Video.CFviVideoBinarize = m_video.Binarize
                bin.Threshold = NumericUpDownThresholdCH0.Value
                '`lOɐݒ
                m_video.BinarizeCH0 = bin
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Threshold CH1 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH1)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownThresholdCH1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownThresholdCH1.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                Dim bin As FVIL.Video.CFviVideoBinarize = m_video.Binarize
                bin.Threshold = NumericUpDownThresholdCH1.Value
                '`lPɐݒ
                m_video.BinarizeCH1 = bin
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' ReLoad Ini File{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' rfIݒpinit@C̍ĐݒB
    ''' </remarks>
    Private Sub ButtonReLoadIni_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReLoadIni.Click
        Try
            't[Ȃ΁A~B
            If (m_flgFreerun = True) Then
                't[~
                fnStopFreerun()
            End If
            '摜bNĂ
            If (m_video.ContinuousGrab.IsMemoryLocked) Then
                '摜bN̉
                m_video.ContinuousGrab.MemoryUnlock()
            End If

            'init@CI
            fnSetIniFile()
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click

        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        Try
            If (ofdlg.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
                Dim name As String
                Dim temp As Integer
                'gq܂ł̕Zo
                temp = ofdlg.FileName.Length - ofdlg.FileName.LastIndexOfAny(".")
                temp = ofdlg.FileName.Length - temp

                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                If (CheckBoxCH0Gray.Checked = True) Then
                    '`lÕOC摜ۑ
                    name = ofdlg.FileName.Insert(temp, "_0Ch")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH1.Image)
                End If
                If (CheckBoxCH1Gray.Checked = True) Then
                    '`lP̃OC摜ۑ
                    name = ofdlg.FileName.Insert(temp, "_1Ch")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH1.Image)
                End If
                If (CheckBoxCH0Bin.Checked = True) Then
                    '`lO̓l摜ۑ
                    name = ofdlg.FileName.Insert(temp, "_0ChBin")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH0BIN.Image)
                End If
                If (CheckBoxCH1Bin.Checked = True) Then
                    '`lP̓l摜ۑ
                    name = ofdlg.FileName.Insert(temp, "_1ChBin")
                    FVIL.File.Function.SaveImageFile(name, CFviImageViewCH1BIN.Image)
                End If

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)
            End If
        Catch ex As FVIL.CFviException
            Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
            Select Case (ex.ErrorCode)
                Case FVIL.ErrorCode.NOT_SUPPORTED, _
                 FVIL.ErrorCode.INVALID_OBJECT
                    msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                    msg += vbCrLf + "Raw `ŕۑĂB"
            End Select
            MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click

        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        '\{̐ݒ
        CFviImageViewCH0.Display.Magnification = 1.0
        CFviImageViewCH1.Display.Magnification = 1.0
        CFviImageViewCH0BIN.Display.Magnification = 1.0
        CFviImageViewCH1BIN.Display.Magnification = 1.0
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH0BIN.Refresh()
        CFviImageViewCH1BIN.Refresh()

    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub ButtonFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click

        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        '\{𒲐
        CFviImageViewCH0.FitImageSize()
        CFviImageViewCH1.FitImageSize()
        CFviImageViewCH0BIN.FitImageSize()
        CFviImageViewCH1BIN.FitImageSize()
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH0BIN.Refresh()
        CFviImageViewCH1BIN.Refresh()

    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub ButtonPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click

        Dim Value As Double
        '{̎擾
        Value = CFviImageViewCH0.Display.Magnification
        '\{̐ݒ
        Value = Value + 0.5
        CFviImageViewCH0.Display.Magnification = Value
        CFviImageViewCH1.Display.Magnification = Value
        CFviImageViewCH0BIN.Display.Magnification = Value
        CFviImageViewCH1BIN.Display.Magnification = Value
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH0BIN.Refresh()
        CFviImageViewCH1BIN.Refresh()

    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click

        Dim Value As Double
        '{̎擾
        Value = CFviImageViewCH0.Display.Magnification
        '\{̐ݒ
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        CFviImageViewCH0.Display.Magnification = Value
        CFviImageViewCH1.Display.Magnification = Value
        CFviImageViewCH0BIN.Display.Magnification = Value
        CFviImageViewCH1BIN.Display.Magnification = Value
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH0BIN.Refresh()
        CFviImageViewCH1BIN.Refresh()

    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged

        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageViewCH0.Display.OverlayAscope.Enable = True
            CFviImageViewCH0.Display.OverlayAscope.Active = True
            CFviImageViewCH1.Display.OverlayAscope.Enable = True
            CFviImageViewCH1.Display.OverlayAscope.Active = True
            CFviImageViewCH0BIN.Display.OverlayAscope.Enable = True
            CFviImageViewCH0BIN.Display.OverlayAscope.Active = True
            CFviImageViewCH1BIN.Display.OverlayAscope.Enable = True
            CFviImageViewCH1BIN.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageViewCH0.Display.OverlayAscope.Enable = False
            CFviImageViewCH0.Display.OverlayAscope.Active = False
            CFviImageViewCH1.Display.OverlayAscope.Enable = False
            CFviImageViewCH1.Display.OverlayAscope.Active = False
            CFviImageViewCH0BIN.Display.OverlayAscope.Enable = False
            CFviImageViewCH0BIN.Display.OverlayAscope.Active = False
            CFviImageViewCH1BIN.Display.OverlayAscope.Enable = False
            CFviImageViewCH1BIN.Display.OverlayAscope.Active = False
        End If
        'ĕ`
        CFviImageViewCH0.Refresh()
        CFviImageViewCH1.Refresh()
        CFviImageViewCH0BIN.Refresh()
        CFviImageViewCH1BIN.Refresh()

    End Sub

    ''' <summary>
    ''' Lv`[eLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Lv`[̃NvB
    ''' </remarks>
    Private Sub TextBoxCaptureNumber_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxCaptureNumber.TextChanged
        Try
            If (TextBoxCaptureNumber.Text < 0) Then
                TextBoxCaptureNumber.Text = 0
            End If
        Catch ex As Exception
            'G[
            'ȊO̓͂10ɏB
            TextBoxCaptureNumber.Text = 10
        End Try

    End Sub

    ''' <summary>
    ''' 捞݉摜I`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' `lÕOC摜I
    ''' </remarks>
    Private Sub CheckBoxCH0Gray_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxCH0Gray.CheckedChanged
        'őmۖ̍ČvZ
        fnCalcMaxImgNum()

    End Sub

    ''' <summary>
    ''' 捞݉摜I`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' `lP̃OC摜I
    ''' </remarks>
    Private Sub CheckBoxCH1Gray_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxCH1Gray.CheckedChanged
        'őmۖ̍ČvZ
        fnCalcMaxImgNum()

    End Sub

    ''' <summary>
    ''' 捞݉摜I`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' `lÔQl摜I
    ''' </remarks>
    Private Sub CheckBoxCH0Bin_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxCH0Bin.CheckedChanged
        'őmۖ̍ČvZ
        fnCalcMaxImgNum()

    End Sub

    ''' <summary>
    ''' 捞݉摜I`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' `lP̂Ql摜I
    ''' </remarks>
    Private Sub CheckBoxCH1Bin_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxCH1Bin.CheckedChanged
        'őmۖ̍ČvZ
        fnCalcMaxImgNum()

    End Sub

    ''' <summary>
    ''' [Jobt@mۍő喇vZ֐
    ''' </summary>
    ''' <remarks>
    ''' mۉ\ő喇Zo
    ''' </remarks>
    Private Sub fnCalcMaxImgNum()
        Dim GrayImgSize As Integer
        Dim BinImgSize As Integer

        GrayImgSize = m_video.ImageHorz * m_video.ImageVert
        BinImgSize = GrayImgSize / 8

        If ((CheckBoxCH0Gray.Checked = False) And (CheckBoxCH1Gray.Checked = False) And (CheckBoxCH0Bin.Checked = False) And (CheckBoxCH1Bin.Checked = False)) Then
            TextBoxMaxImgNum.Text = "0"
            NumericUpDownBufConfigNum.Value = 0
        Else
            Dim ImgSize As Integer = 0
            Dim TotalSize As Integer = 0
            Dim Count As Integer = 0
            Dim frame_size As Integer

            If (CheckBoxCH0Gray.Checked = True) Then
                ImgSize = ImgSize + GrayImgSize
            End If
            If (CheckBoxCH1Gray.Checked = True) Then
                ImgSize = ImgSize + GrayImgSize
            End If
            If (CheckBoxCH0Bin.Checked = True) Then
                ImgSize = ImgSize + BinImgSize
            End If
            If (CheckBoxCH1Bin.Checked = True) Then
                ImgSize = ImgSize + BinImgSize
            End If
            Count = FVC05_LOCALMEM_SIZE \ ImgSize
            For i As Integer = Count To 0 Step -1
                If ((i * GrayImgSize) And LOCAL_BUFFER_MASK) Then
                    frame_size = ((i * GrayImgSize) And (Not LOCAL_BUFFER_MASK)) + LOCAL_BUFFER_BOUNDARY
                Else
                    frame_size = (i * GrayImgSize)
                End If
                If (CheckBoxCH0Gray.Checked = True) Then
                    TotalSize = TotalSize + frame_size
                End If
                If (CheckBoxCH1Gray.Checked = True) Then
                    TotalSize = TotalSize + frame_size
                End If
                If ((i * BinImgSize) And LOCAL_BUFFER_MASK) Then
                    frame_size = ((i * BinImgSize) And (Not LOCAL_BUFFER_MASK)) + LOCAL_BUFFER_BOUNDARY
                Else
                    frame_size = (i * BinImgSize)
                End If
                If (CheckBoxCH0Bin.Checked = True) Then
                    TotalSize = TotalSize + frame_size
                End If
                If (CheckBoxCH1Bin.Checked = True) Then
                    TotalSize = TotalSize + frame_size
                End If
                If (TotalSize <= FVC05_LOCALMEM_SIZE) Then
                    Count = i
                    Exit For
                Else
                    TotalSize = 0
                End If
            Next
            TextBoxMaxImgNum.Text = Count.ToString
            NumericUpDownBufConfigNum.Value = Count
        End If

    End Sub

    ''' <summary>
    ''' [Jobt@mۖ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' [Jobt@mۖ̃Nv
    ''' </remarks>
    Private Sub NumericUpDownBufConfigNum_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownBufConfigNum.ValueChanged
        If (NumericUpDownBufConfigNum.Value > Integer.Parse(TextBoxMaxImgNum.Text)) Then
            NumericUpDownBufConfigNum.Value = Integer.Parse(TextBoxMaxImgNum.Text)
        End If

    End Sub

    ''' <summary>
    ''' [Jobt@mۖ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' [Jobt@mۖ̃Nv
    ''' </remarks>
    Private Sub NumericUpDownBufConfigNum_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles NumericUpDownBufConfigNum.KeyUp
        If (NumericUpDownBufConfigNum.Value > Integer.Parse(TextBoxMaxImgNum.Text)) Then
            NumericUpDownBufConfigNum.Value = Integer.Parse(TextBoxMaxImgNum.Text)
        End If

    End Sub

End Class
